/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello  */
/*                                                                          */
/*                                                                          */
/*          This module was originally written by Vince Perriello           */
/*                                                                          */
/*                                                                          */
/*                       BinkleyTerm Opening Banner                         */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.210.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU SHOULD  IMMEDIATELY CONTACT THE AUTHORS    */
/*    AT THE  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO    */
/*    USE   THIS  FILE  WITHOUT  HAVING   ACCEPTED  THE  TERMS  OF   THE    */
/*    BINKLEYTERM  LICENSING AGREEMENT,  OR SUCH OTHER  AGREEMENT AS YOU    */
/*    ARE ABLE TO REACH WITH THE AUTHORS.                                   */
/*                                                                          */
/*                                                                          */
/*    The Authors can be reached at the following addresses:                */
/*                                                                          */
/*    Robert C. Hartman                      Vincent E. Perriello           */
/*    Spark Software                         VEP Software                   */
/*    427-3 Amherst Street                   111 Carroll Street             */
/*    CS2032, Suite 232                      Naugatuck, CT 06770            */
/*    Nashua, NH 03061                                                      */
/*                                                                          */
/*    FidoNet 1:132/101                      FidoNet 1:141/491              */
/*    Data    (603) 888-8179                 Data    (203) 729-7569         */
/*                                                                          */
/*    Please feel free to contact us at any time to share your comments     */
/*    about our software and/or licensing policies.                         */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <string.h>
#include <stdlib.h> /*PLF Sat  05-06-1989; needed for _osmode */

#include "com.h"
#include "xfer.h"
#include "zmodem.h"
#include "keybd.h"
#include "sbuf.h"
#include "sched.h"
#include "externs.h"
#include "prototyp.h"

static void mtask_find (void);

void opening_banner ()
{
   char bd[10];

   if (!fullscreen || !un_attended)
      {
      scr_printf ("\033[H\033[2J");
      scr_printf (ANNOUNCE);
      scr_printf ("\r\nA Freely Available Dumb Terminal and FidoNet Mail Package\r\n");
      scr_printf ("Setting COM");
      WRITE_ANSI (port_ptr + '1');
      scr_printf (": to initial speed of ");
      sprintf (bd, "%d", max_baud);
      scr_printf (bd);
      scr_printf (" baud. Press Alt-F10 for HELP.\r\n");
      }

   fossil_ver ();
   mtask_find ();
}

static void mtask_find ()
{
   char buff[80];
   int fs1, fs2;

   fs1 = fullscreen && (un_attended || doing_poll);
   fs2 = (!fullscreen) || !(un_attended || doing_poll);

   if (fs2)
      {
      scr_printf ("Multi-Tasker: ");
      }
#ifndef OS_2 /*PLF Fri  05-05-1989  07:03:30 */
   if ((have_dv = dv_get_version ()) != 0)
      {
      if (fs1)
         {
         sprintf (buff, "DESQview");
         }
      else
         {
         sprintf (buff, "DESQview version %d.%02d detected\r\n",
                  have_dv >> 8, have_dv & 0xff);
         }
      }
   else if ((have_ddos = ddos_active ()) != 0)
      {
      if (fs1)
         {
         strcpy (buff, "DoubleDOS");
         }
      else
         {
         strcpy (buff, "DoubleDOS detected\r\n");
         }
      }
   else if (have_ml)
      {
      if ((have_ml = ml_active ()) != 0)
         {
         if (fs1)
            {
            strcpy (buff, "MultiLink");
            }
         else
            {
            strcpy (buff, "MultiLink detected\r\n");
            }
         }
      else
         {
         if (fs1)
            {
            strcpy (buff, "None");
            }
         else
            {
            strcpy (buff, "None detected\r\n");
            }
         }
      }
   else if (have_tv)
      {
      if ((have_tv = tv_get_version ()) != 0)
         {
         if (fs1)
            {
            strcpy (buff, "T-View");
            }
         else
            {
            strcpy (buff, "TopView/TaskView detected\r\n");
            }
         }
      else
         {
         if (fs1)
            {
            strcpy (buff, "None");
            }
         else
            {
            strcpy (buff, "None detected\r\n");
            }
         }
      }
   else
      {
      if (fs1)
         {
         strcpy (buff, "None");
         }
      else
         {
         strcpy (buff, "None detected\r\n");
         }
      }
#else /*PLF Fri  05-05-1989  07:03:59 */
    if( _osmode == DOS_MODE )
        strcpy(buff, "None");
    else
        strcpy(buff, "OS/2");
    if(!fs1) strcat(buff, "\r\n");
#endif /*PLF Fri  05-05-1989  07:03:59 */
   if (fs2)
      {
      scr_printf (buff);
      }
   else
      {
      sb_move (settingswin, SET_TASK_ROW, 2);
      sb_puts (settingswin, "M'Task: ");
      sb_puts (settingswin, buff);
      }
}
