/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello  */
/*                                                                          */
/*                                                                          */
/*               This module was written by Vince Perriello                 */
/*                                                                          */
/*                                                                          */
/*                       BinkleyTerm "HELP" Module                          */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.210.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU SHOULD  IMMEDIATELY CONTACT THE AUTHORS    */
/*    AT THE  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO    */
/*    USE   THIS  FILE  WITHOUT  HAVING   ACCEPTED  THE  TERMS  OF   THE    */
/*    BINKLEYTERM  LICENSING AGREEMENT,  OR SUCH OTHER  AGREEMENT AS YOU    */
/*    ARE ABLE TO REACH WITH THE AUTHORS.                                   */
/*                                                                          */
/*                                                                          */
/*    The Authors can be reached at the following addresses:                */
/*                                                                          */
/*    Robert C. Hartman                      Vincent E. Perriello           */
/*    Spark Software                         VEP Software                   */
/*    427-3 Amherst Street                   111 Carroll Street             */
/*    CS2032, Suite 232                      Naugatuck, CT 06770            */
/*    Nashua, NH 03061                                                      */
/*                                                                          */
/*    FidoNet 1:132/101                      FidoNet 1:141/491              */
/*    Data    (603) 888-8179                 Data    (203) 729-7569         */
/*                                                                          */
/*    Please feel free to contact us at any time to share your comments     */
/*    about our software and/or licensing policies.                         */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#include <stdio.h>

#include "com.h"
#include "xfer.h"
#include "zmodem.h"
#include "keybd.h"
#include "sbuf.h"
#include "sched.h"
#include "externs.h"
#include "prototyp.h"

static char    *mhelp[] = {
   "\033[H\033[2J",
   "You now have BinkleyTerm in DUMB TERMINAL mode.\r\n",
   "In DUMB TERMINAL mode the following special keys are enabled:\r\n\r\n",
   "Alt-B   Cycle baud rate              Alt-C   Change communications parameters\r\n",
   "Alt-D   Dial a system                Alt-H   Hang up by dropping DTR\r\n",
   "Alt-J   Jump to DOS temporarily      Alt-L   Start/stop logging to a file\r\n",
   "Alt-M   Manual poll                  Alt-P   Cycle communications port\r\n",
   "Alt-R   Redial from a 'scan list'    Alt-S   Send BREAK signal to port\r\n",
   "Alt-U   Go to UNATTENDED MAILER mode Alt-X   Exit BinkleyTerm\r\n",
   "Alt-Y   Call boss node for mail\r\n",
   "PgUp    Send a file (UPLOAD)         PgDn    Receive a file (DOWNLOAD)\r\n",
   NULL
};

static char    *uhelp[] = {
   "\033[H\033[2J",
   "You now have BinkleyTerm in UNATTENDED MAILER mode.\r\n",
   "In UNATTENDED MAILER mode the following special keys are enabled:\r\n\r\n",
   "     C          Make the next call (if any) immediately\r\n",
   "     Alt-C      Clear data from the \"Today at a Glance\" window.\r\n",
   "     Alt-J/ESC  Push to DOS (spawn COMMAND.COM)\r\n",
   "     Alt-M      Manually POLL a node\r\n",
   "     Alt-Q      Quit the current event\r\n",
   "     Alt-R      Re-start mail events as though none have previously executed\r\n",
   "     Alt-T      Shift into DUMB TERMINAL mode.\r\n",
   "     Alt-W      Redraw screen.\r\n"
   "     Alt-X      Exit from BT with ERRORLEVEL 1\r\n",
   "     cursorkeys PGUP/DN, UP/DN ARROW, HOME, and END scroll the 'Pending' window\r\n",
   "     F1..F10    Exit to DOS with errorlevel (10*n) (F1=10,etc)\r\n",
   NULL
};

void main_help ()
{
   char *c;
   int i;
   char j[100];

   for (i = 0; mhelp[i] != NULL; i++)
      scr_printf (mhelp[i]);

   for (i = 0; i < 9; i++)
      {
      if (keys[i] != NULL)
         {
         c = keys[i];
         while (*c && (*c != '\n'))
            {
            if (*c == '\r')
               *c = '|';
            ++c;
            }

         sprintf (j, "Alt-F%-2d Macro string '%s'\r\n", i + 1, keys[i]);
         scr_printf (j);

         c = keys[i];
         while (*c && (*c != '\n'))
            {
            if (*c == '|')
               *c = '\r';
            ++c;
            }
         }
      }

   scr_printf ("\r\nPress a key to continue...");
   FOSSIL_CHAR ();
   scr_printf ("\r\n");
}

void mailer_help ()
{
   int i;
   char j[100];

   for (i = 0; uhelp[i] != NULL; i++)
      scr_printf (uhelp[i]);

   if (do_screen_blank)
      {
      scr_printf ("     Alt-B      Blank the screen immediately\r\n");
      }
      
   if (BBSreader != NULL)
      {
      scr_printf ("     Alt-E      Execute '");
      scr_printf (BBSreader);
      scr_printf ("' as message editor\r\n");
      }

   for (i = 0; i < 9; i++)
      {
      if (shells[i] != NULL)
         {
         sprintf (j, "     Alt-F%-2d   Execute '%s'\r\n", i + 1, shells[i]);
         scr_printf (j);
         }
      }

   scr_printf ("\r\nPress a key to continue...");
   FOSSIL_CHAR ();
   scr_printf ("\r\n");
}
