/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software <no-Inc>                   */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          No-Cost<no-tm> Software.                       */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*  Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello  */
/*                                                                          */
/*                                                                          */
/*           This module was originally written by Bob Hartman              */
/*                                                                          */
/*                                                                          */
/*           BinkleyTerm "Main" Module: Terminal Emulation and              */
/*                       File Transfer dispatching                          */
/*                                                                          */
/*                                                                          */
/*                       BinkleyTerm Licensing Terms                        */
/*                                                                          */
/*                                                                          */
/* Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello.  */
/* ALL RIGHTS RESERVED. COMMERCIAL DISTRIBUTION AND/OR USE PROHIBITED       */
/* WITHOUT WRITTEN PERMISSION FROM ROBERT HARTMAN AND VINCENT PERRIELLO.    */
/*                                                                          */
/* Non-Commercial distribution and/or use is permitted under the following  */
/* terms:                                                                   */
/*                                                                          */
/*                                                                          */
/* 1. You may copy and distribute verbatim copies of BinkleyTerm source and */
/* executable code as you receive it, in any medium, provided that you      */
/* conspicuously and appropriately publish on each copy a valid copyright   */
/* notice "Copyright (C) 1987, 1988, 1989 Robert Hartman and Vincent        */
/* Perriello"; keep intact the notices on all files that refer to this      */
/* License Agreement and to the absence of any warranty;  PROVIDE UNMODIFIED*/
/* COPIES OF THE DOCUMENTATION AS PROVIDED WITH THE PROGRAM; and give any   */
/* other recipients of the BinkleyTerm program a copy of this License       */
/* Agreement along with the program.  You may charge a distribution fee for */
/* the physical act of transferring a copy, but no more than is necessary to*/
/* recover your actual costs incurred in the transfer. Under no             */
/* circumstances is BinkleyTerm to be distributed in such a way as to be    */
/* construed as "value added" in a sales transaction, such as, but not      */
/* limited to, software bundled with a modem or CD-ROM software             */
/* collections.                                                             */
/*                                                                          */
/* 2. You may modify your copy or copies of BinkleyTerm or any portion of   */
/* it, and copy and distribute such modifications under the terms of        */
/* Paragraph 1 above, provided that you also do the following:              */
/*                                                                          */
/*     a) cause the modified files to carry prominent notices stating       */
/*     that you changed the files and the date of any change;               */
/*                                                                          */
/*     b) cause the executable code of such modified version to clearly     */
/*     identify itself as such in the course of its normal operation;       */
/*                                                                          */
/*     c) if the modified version is not a "port", but operates in the      */
/*     same hardware and/or software environment as the original            */
/*     distribution, make the original version equally available,           */
/*     clearly identifying same as the original, unmodified version;        */
/*                                                                          */
/*     d) cause the whole of any work that you distribute or publish,       */
/*     that in whole or in part contains or is a derivative of              */
/*     BinkleyTerm or any part thereof, to be licensed at no charge to      */
/*     all third parties on terms identical to those contained in this      */
/*     License Agreement (except that you may choose to grant more          */
/*     extensive warranty protection to some or all third parties, at       */
/*     your option); and                                                    */
/*                                                                          */
/*     e) send the complete source code modifications to either or both     */
/*     of the Authors at one of the addresses listed below, for their       */
/*     evaluation for inclusion in future releases of BinkleyTerm.          */
/*     Should your source code be included in BinkleyTerm, the Authors      */
/*     retain all rights for redistribution of the code as part of          */
/*     BinkleyTerm and all derivative works, with appropriate credit        */
/*     given to the author of the modification.                             */
/*                                                                          */
/*     f) You may charge a distribution fee for the physical act of         */
/*     transferring a copy, but no more than is necessary to recover        */
/*     your actual costs incurred in the transfer, and you may at your      */
/*     option offer warranty protection in exchange for a fee.              */
/*                                                                          */
/* 3. Mere aggregation of another unrelated program with this program (or   */
/* its derivative) on a volume of a storage or distribution medium does not */
/* bring the other program under the scope of these terms.                  */
/*                                                                          */
/* 4. You may copy and distribute BinkleyTerm (or a portion or derivative   */
/* of it, under Paragraph 2) in object code or executable form under the    */
/* terms of Paragraphs 1 and 2 above provided that you also do one of the   */
/* following:                                                               */
/*                                                                          */
/*     a) accompany it with the complete corresponding machine-readable     */
/*     source code, which must be distributed under the terms of            */
/*     Paragraphs 1 and 2 above; or,                                        */
/*                                                                          */
/*     b) accompany it with a written offer, valid for at least three       */
/*     years, to give any third party free (except for a nominal            */
/*     shipping charge) a complete machine-readable copy of the             */
/*     corresponding source code, to be distributed under the terms of      */
/*     Paragraphs 1 and 2 above; or,                                        */
/*                                                                          */
/*     c) accompany it with the information you received as to where        */
/*     the corresponding source code may be obtained.  (This                */
/*     alternative is allowed only for noncommercial distribution and       */
/*     only if you received the program in object code or executable        */
/*     form alone.)                                                         */
/*                                                                          */
/* For an executable file, complete source code means all the source code   */
/* for all modules it contains; but, as a special exception, it need not    */
/* include source code for modules which are standard libraries that        */
/* accompany the operating system on which the executable file runs.        */
/*                                                                          */
/* 5. You may not copy, sublicense, distribute or transfer BinkleyTerm      */
/* except as expressly provided under this License Agreement.  Any attempt  */
/* otherwise to copy, sublicense, distribute or transfer BinkleyTerm is     */
/* void and your rights to use the program under this License agreement     */
/* shall be automatically terminated.  However, parties who have received   */
/* computer software programs from you with this License Agreement will not */
/* have their licenses terminated so long as such parties remain in full    */
/* compliance, and notify the Authors of their intention to comply with     */
/* this Agreement.                                                          */
/*                                                                          */
/* 6. If you wish to incorporate parts of BinkleyTerm into other free       */
/* programs whose distribution conditions are different, please contact     */
/* either Robert Hartman or Vincent Perriello, at the addresses listed      */
/* below.  We have not yet worked out a simple rule that can be stated      */
/* here, but we will usually permit this.  We will be guided by the two     */
/* goals of preserving the free status of all derivatives of our free       */
/* software (as it pertains to Non-Commercial use as provided by this       */
/* Agreement) and of promoting the sharing and reuse of software.           */
/*                                                                          */
/* 7. For the purposes of this document, "COMMERCIAL USE" is defined as     */
/* concurrent operation of the software on four or more computers or data   */
/* lines owned by the same for-profit organization. Any organization may    */
/* operate this software under the terms of this Non-Commercial Agreement   */
/* if operation is limited to three or less computers or data lines.        */
/*                                                                          */
/*                                                                          */
/*                              NO WARRANTY                                 */
/*                                                                          */
/* BECAUSE BINKLEYTERM IS LICENSED FREE OF CHARGE, WE PROVIDE ABSOLUTELY NO */
/* WARRANTY.  EXCEPT WHEN OTHERWISE STATED IN WRITING, ROBERT HARTMAN,      */
/* VINCENT PERRIELLO AND/OR OTHER PARTIES PROVIDE BINKLEYTERM "AS IS"       */
/* WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,    */
/* BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND        */
/* FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND */
/* PERFORMANCE OF BINKLEYTERM IS WITH YOU.  SHOULD BINKLEYTERM PROVE        */
/* DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR     */
/* CORRECTION.                                                              */
/*                                                                          */
/* IN NO EVENT WILL ROBERT HARTMAN AND VINCENT PERRIELLO BE RESPONSIBLE IN  */
/* ANY WAY FOR THE BEHAVIOR OF MODIFIED VERSIONS OF BINKLEYTERM. IN NO      */
/* EVENT WILL ROBERT HARTMAN, VINCENT PERRIELLO, AND/OR ANY OTHER PARTY WHO */
/* MAY MODIFY AND REDISTRIBUTE BINKLEYTERM AS PERMITTED ABOVE, BE LIABLE TO */
/* YOU FOR DAMAGES, INCLUDING ANY LOST PROFITS, LOST MONIES, OR OTHER       */
/* SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR   */
/* INABILITY TO USE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA      */
/* BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY THIRD PARTIES OR A      */
/* FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS) BINKLEYTERM,  */
/* EVEN IF YOU HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES, OR FOR */
/* ANY CLAIM BY ANY OTHER PARTY.                                            */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/* The Authors can be reached at the following addresses:                   */
/*                                                                          */
/* Robert C. Hartman                      Vincent E. Perriello              */
/* Spark Software                         VEP Software                      */
/* 427-3 Amherst Street                   111 Carroll Street                */
/* CS2032, Suite 232                      Naugatuck, CT 06770               */
/* Nashua, NH 03061                                                         */
/*                                                                          */
/* FidoNet 1:132/101                      FidoNet 1:141/491                 */
/* Data    (603) 888-8179                 Data    (203) 729-7569            */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/* Our thanks to Richard Stallman and the Free Software Foundation, Inc.,   */
/* for most of the wording of this License.                                 */
/*                                                                          */
/*--------------------------------------------------------------------------*/


#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>

#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#endif

#include "com.h"
#include "xfer.h"
#include "zmodem.h"
#include "keybd.h"
#include "sbuf.h"
#include "sched.h"
#include "externs.h"
#include "prototyp.h"

static int handler(void);   /*PLF Sun  05-07-1989  02:37:33 */

void main (argc, argv)
int argc;
char *argv[];
{
   int k;
   int c;
   int done;
   long t1;
   char *envptr;
   FILE *logfile = NULL;                         /* log file stream
                                                  * descriptor */
   char prot;
   char *p;                                      /* Used for external
                                                  * protocol */
   int err;
   int mail_only = 0;                            /* if 1, do mail and exit     */
   int bzone, bnet, bnode;

#ifdef OS_2 /*PLF Sun  05-07-1989  02:36:27 */
    if (signal(SIGINT, handler) == (int(*) ()) -1) {
        fprintf(stderr, "Couldn't set SIGINT");
        return;
    }
#else
   signal (SIGINT, SIG_IGN);
#endif

   b_initvars ();

   while (--argc)
      {
      ++argv;

      switch (parse (argv[0], DOS_commands))
         {
         case 1:                                /* Noforce    */
            noforce = 1;
            break;

         case 2:                                /* Mail       */
            ++mail_only;
            break;

         case 3:                                /* Share      */
            ++share;
            break;

         case 4:                                /* Dynam      */
            ++redo_dynam;
            break;

         case 5:                                /* Unattended */
            un_attended = 1;
            command_line_un = 1;
            break;

         case 6:                                /* Config     */
            config_name = argv[1];
            --argc;
            ++argv;
            break;

         case 7:                                /* Poll       */
            if (sscanf (argv[1], "%d:%d/%d", &bzone, &bnet, &bnode) != 3)
               {
               if (sscanf (argv[1], "%d/%d", &bnet, &bnode) != 2)
                  {
                  printf ("Cannot decipher '%s' as node number\n", argv[1]);
                  }
               else
                  {
                  bzone = 0;
                  doing_poll = 1;
                  }
               }
            else
               {
               doing_poll = 1;
               }
            --argc;
            ++argv;
            break;

         default:                               /* Not there  */
            printf ("\r\nUnrecognized option: %s\r\n", argv[0]);
            exit (1);
         }
      }

   envptr = getenv ("BINKLEY");                  /* get path from environment */
   if ((envptr != NULL)                          /* If there was one, and     */
       && (!dexists (config_name)))              /* No BINKLEY.CFG locally,   */
      {
      BINKpath = malloc (strlen (envptr) + 2);   /* make room for new */
      strcpy (BINKpath, envptr);                 /* use BINKLEY as our path   */
      add_backslash (BINKpath);
      }

   read_sched ();
   parse_config ("Binkley.Evt");
   parse_config (config_name);
   b_defaultvars ();

   if (Cominit (port_ptr) != 0x1954)
      {
#ifndef OS_2    /*PLF Sat  05-06-1989  05:24:32 */
      printf ("I'm sorry, there doesn't appear to be a FOSSIL driver loaded.\r\n");
      printf ("BinkleyTerm requires a FOSSIL driver. Please take care of this before\r\n");
      printf ("attempting to run BinkleyTerm again.\r\n");
#else
      printf("\aCouldn't initialize COM port. Check config.sys for COM0?.SYS\n");
      printf("or make sure the network is started if you are using a modem\n");
      printf("on another computer.\n");
#endif
      exit (1);
      }

   LoadScanList (0,0);                           /* Get default scan list    */

   k = un_attended;
   un_attended = 0;
   set_baud (max_baud, 0);
   un_attended = k;
   MDM_ENABLE (btypes[baud].rate);
   DTR_ON ();
   XON_ENABLE ();
   done = 0;

   if (fullscreen)
      b_sbinit ();

   Txbuf = Secbuf = zalloc ();

   if (mail_only)
      {
      un_attended = 1;
      opening_banner ();
      mailer_banner ();
      if (fullscreen)
         {
         sb_move (holdwin, 3, 7);
         sb_puts (holdwin, " Polling Boss Node   ");
         sb_show ();
         }
      boss_mail (1);
      un_attended = 0;
      done = 1;
      }
   else if (un_attended)
      {
      done = unattended ();
      }
   else if (doing_poll)
      {
      if (bzone == 0)
         bzone = alias[0].Zone;
      un_attended = 1;
      opening_banner ();
      mailer_banner ();
      if (fullscreen)
         {
         sb_move (holdwin, 3, 7);
         sprintf (junk, " Polling %d:%d/%d     ", bzone, bnet, bnode);
         sb_puts (holdwin, junk);
         sb_show ();
         }
      if (!CARRIER)
         mdm_hangup ();
      do_mail (bzone, bnet, bnode, 1);
      un_attended = 0;
      done = 1;
      }
   else
      {
      opening_banner ();
      }

   vfossil_cursor (1);
   while (!done)
      {
      c = -1;
      if (CHAR_AVAIL ())
         {
         static int lastchar = 0;   /*PLF Sat  05-06-1989  08:20:00 */
         c = MODEM_IN ();

         if (comm_bits == BITS_7)
            c &= 0x7f;

/*PLF Sat  05-06-1989  08:12:58; add zmodem autodownload start */
         if(c==ZPAD && lastchar==ZPAD && (PEEKBYTE()==ZDLE)){
            lastchar = 0;
            get_Zmodem (download_path, NULL);
            gong();
         }
        lastchar = c;
/*PLF Sat  05-06-1989  08:12:58; add zmodem autodownload end   */
/*
 * I really don't like looking for this piece of crap, but people
 * seem to really want it, so I guess I lose.  Now if only TBBS and
 * QuickBBS would do things that were ANSI compatible - ugh!
 */
         if (c == '')
            {
            scr_printf ("\033[H\033[2J");
            }
         else if (c == ENQ)
            {
            mdm_cmd_string (answerback, 1);
            }
         else
            {
            WRITE_ANSI (c);
            }

         if (logfile != NULL)
            {
            fwrite (&c, 1, 1, logfile);
            }
         }
      if (KEYPRESS () || ctrlc_ctr)
         {
         c = 0;
         if (ctrlc_ctr)
            {
            /* We got a ^C, so output it properly */
            while (KEYPRESS ())                  /* Flush keyboard buffer */
               FOSSIL_CHAR ();
            ctrlc_ctr = 0;
            while (Com_Tx_NW (3) == 0)
               ;
            continue;
            }
         k = FOSSIL_CHAR ();
         switch (k)
            {
            case ALTB:
               ++baud;
               if (btypes[baud].str == NULL)
                  baud = 0;
               MDM_ENABLE (btypes[baud].rate);
               cur_baud = atoi (btypes[baud].str);
               scr_printf ("\r\nBinkleyTerm now communicating at ");
               scr_printf (btypes[baud].str);
               scr_printf (" baud.\r\n");
               break;

            case ALTC:
               scr_printf ("\r\n7 or 8 data bits? ");
               fgets (junk, 100, stdin);
               comm_bits = (atoi (junk) == 7) ? BITS_7 : BITS_8;
               if (comm_bits == BITS_8)
                  {
                  parity = NO_PARITY;
                  }
               else
                  {
                  scr_printf ("(E)ven, (O)dd, or (N)o parity? ");
                  fgets (junk, 100, stdin);
                  strupr (junk);
                  parity = (junk[0] == 'E') ? EVEN_PARITY :
                     ((junk[0] == 'O') ? ODD_PARITY : NO_PARITY);
                  }
               scr_printf ("1 or 2 stop bits? ");
               fgets (junk, 100, stdin);
               stop_bits = (atoi (junk) == 1) ? STOP_1 : STOP_2;

               MDM_ENABLE (btypes[baud].rate);
               break;

            case ALTD:
               scr_printf ("\r\nPlease enter a phone (or net/node) number: ");
               if (!get_number (junk))
                  break;
               if (strchr (junk, '/') != NULL)
                  {
                  if (nodeproc (junk))
                     {
                     strcpy (junk, newnodedes.PhoneNumber);
                     }
                  else break;
                  }
               caller = 0;
               try_2_connect (junk);             /* try to connect         */
               gong ();
               break;

            case ALTH:
               t1 = timerset (300);
               while (CARRIER)
                  if (timeup (t1))
                     {
                     scr_printf ("\r\nUnable to force carrier drop by dropping DTR!\r\n");
                     break;
                     }
                  else
                     {
                     DTR_OFF ();
                     }
               status_line (":Connection terminated");
               DTR_ON ();
               break;

            case ALTJ:
               scr_printf ("\r\nExiting to DOS\r\n");
               scr_printf ("Type EXIT to return to BT");
               MDM_DISABLE ();
               change_prompt ();
               b_spawn (NULL);
               /* Re-enable ourselves */
               if (Cominit (port_ptr) != 0x1954)
                  {
                  printf ("\r\nDarn!  The FOSSIL seems to have gone away!  Exiting\r\n");
                  exit (1);
                  }
               scr_printf ("\r\nWelcome back!\r\n");
               DTR_ON ();
               MDM_ENABLE (btypes[baud].rate);
               break;

            case ALTL:
               if (logfile != NULL)
                  {
                  fclose (logfile);
                  logfile = NULL;
                  scr_printf ("\r\nLog file closed.\r\n");
                  break;
                  }

               if ((logptr == NULL) || (*logptr == '\0'))
                  {
                  scr_printf ("\r\nLog file name: ");
                  fgets (capturename, 100, stdin);
                  k = strlen (capturename);
                  capturename[--k] = '\0'; /* no '\n' */
                  }
               else
                  {
                  strcpy (capturename, logptr);
                  k = 1;
                  }
               if (k)
                  {
                  logfile = fopen (capturename, "ab");
                  if (logfile == NULL)
                     scr_printf ("\r\nCould not open specified logfile.\r\n");
                  }
               break;

            case ALTM:
               scr_printf ("\r\nPlease enter a net/node number: ");
               if (!get_number (junk))
                  break;
               if ((k = sscanf (junk, "%d:%d/%d", &bzone, &bnet, &bnode)) != 3)
                  {
                  bzone = 0;
                  if ((k = sscanf (junk, "%d/%d", &bnet, &bnode)) != 2)
                     {
                     bnet = alias[0].Zone;
                     bnet = alias[0].Net;
                     if ((k = sscanf (junk, "%d", &bnode)) == 1)
                        {
                        k = 3;
                        }
                     }
                  else
                     {
                     k = 3;
                     }
                  }
               if (k >= 2)
                  {
                  if (bnet >= 0 && bnode >= 0)
                     {
                     if (!nodefind (bzone, bnet, bnode, 1))
                        break;
                     if (!bzone)
                        bzone = found_zone;
                     un_attended = 1;
                     if (fullscreen)
                        {
                        sb_dirty ();
                        opening_banner ();
                        mailer_banner ();
                        sb_fill (holdwin, ' ', colors.hold);
                        sb_move (holdwin, 3, 7);
                        sprintf (junk, " Polling %d:%d/%d     ", bzone, bnet, bnode);
                        sb_puts (holdwin, junk);
                        sb_show ();
                        }
                     else
                        {
                        scr_printf ("\r\nBinkleyTerm now in MAILER mode\r\n");
                        }
                     if (!CARRIER)
                        mdm_hangup ();
                     do_mail (bzone, bnet, bnode, 1);
                     un_attended = 0;
                     if (fullscreen)
                        {
                        scr_printf ("\033[H\033[2J");
                        scr_printf ("BinkleyTerm now in MANUAL mode\r\n");
                        }
                     else
                        {
                        scr_printf ("\r\nBinkleyTerm now in MANUAL mode\r\n");
                        }
                     gong ();
                     vfossil_cursor (1);
                     break;
                     }
                  }
               cprintf ("\r\nCannot get net/node from '%s'\r\n", junk);
               break;

            case ALTP:
               c = port_ptr;    /*PLF Sun  05-07-1989  23:57:36 */
               if (++port_ptr == MAXport)
                  port_ptr = 0;
               MDM_DISABLE ();
               if(!Cominit (port_ptr) != 0x1954 )   /*PLF Mon  05-08-1989  00:04:40 */
               {
                  port_ptr = c;
                  Cominit(port_ptr);
               }
               MDM_ENABLE (btypes[baud].rate);
               DTR_ON ();
               scr_printf ("\r\nBinkleyTerm now using COM");
               WRITE_ANSI (port_ptr + '1');
               scr_printf (":\r\n");
               XON_ENABLE ();
               break;

            case ALTR:
               if (!list_search ())
                  cprintf ("\033[H\033[J\n");
               break;

            case ALTS:
               if (old_fossil)
                  {
                  scr_printf ("\r\nRevision 3 FOSSIL driver does not support BREAK signal\r\n");
                  }
               else
                  {
                  scr_printf ("\r\nSending BREAK signal\r\n");
                  send_break (100);
                  scr_printf ("Done\r\n");
                  }
               break;

            case ALTU:
               done = unattended ();
               vfossil_cursor (1);
               break;

            case ALTX:
               if (logfile != NULL)
                  fclose (logfile);
               done = 1;
               break;

            case ALTY:
               scr_printf ("\r\nBinkleyTerm now in MAILER mode\r\n");
               boss_mail (1);
               scr_printf ("\r\nBinkleyTerm now in MANUAL mode\r\n");
               break;

            case PGUP:
               XON_DISABLE ();
               scr_printf ("\r\nBinkleyTerm is ready to SEND a file...\r\n");
               scr_printf ("Which Protocol do you want BinkleyTerm to use?\r\n");
               scr_printf ("Z)modem     Y)modem     S)EAlink     T)elink     X)modem\r\n");
               if (extern_protocols != NULL)
                  {
                  scr_printf (extern_protocols);
                  scr_printf ("\r\n");
                  }
               scr_printf ("OK....Choose! ");
               fgets (junk, 100, stdin);
               prot = toupper (junk[0]);
               p = NULL;
               if ((strchr (native_protocols, prot) == NULL)
                   && ((p = strchr (extern_protocols, prot)) == NULL))
                  {
                  scr_printf ("Sorry. I don't know that protocol, returning to terminal mode.\r\n");
                  break;
                  }
               scr_printf ("File to be sent? ");
               fgets (junk, 100, stdin);
               junk[strlen (junk) - 1] = '\0';
               err = 1;                          /* Xmodem, Ymodem, Telink
                                                  * flag */
               if (p)
                  {
                  do_extern ("Send", prot, junk);
                  err = 0;
                  }
               else if (prot == 'Z')
                  {
                  Send_Zmodem (junk, NULL, 0, 0);
                  Send_Zmodem (NULL, NULL, END_BATCH, 0);
                  err = 0;
                  }
               if (prot == 'T')
                  err = xfermdm7 (junk);
               if (err)                          /* 'X','Y' or good MDM7
                                                  * filename */
                  {
                  send_file (junk, prot);
                  send_file (NULL, prot);
                  }
               XON_ENABLE ();
               gong ();
               break;

            case PGDN:
               XON_DISABLE ();
               scr_printf ("\r\nBinkleyTerm is ready to RECEIVE a file...\r\n");
               scr_printf ("Which Protocol do you want BinkleyTerm to use?\r\n");
               scr_printf ("Z)modem     Y)modem     S)EAlink     T)elink     X)modem\r\n");
               if (extern_protocols != NULL)
                  {
                  scr_printf (extern_protocols);
                  scr_printf ("\r\n");
                  }
               scr_printf ("OK....Choose! ");
               fgets (junk, 100, stdin);
               prot = toupper (junk[0]);
               junk[0] = '\0';
               p = NULL;
               if ((strchr (native_protocols, prot) == NULL)
                   && ((p = strchr (extern_protocols, prot)) == NULL))
                  {
                  scr_printf ("Sorry. I don't know that protocol, returning to terminal mode.\r\n");
                  break;
                  }
               err = 1;                          /* Telink batch flag */
               if ((prot == 'X') || (prot == 'Y') || p != NULL)
                  {
                  scr_printf ("File to receive? ");
                  fgets (junk, 100, stdin);
                  junk[strlen (junk) - 1] = '\0';
                  if (p)
                     {
                     do_extern ("Get", prot, junk);
                     }
                  else receive_file (download_path, junk, prot);
                  err = 0;
                  }
               if (prot == 'Z')
                  {
                  get_Zmodem (download_path, NULL);
                  err = 0;
                  }

               /*
                * If not Telink, err is now zero. If Telink, it should still
                * be one. 
                */
               while (err)
                  {
                  if (prot == 'T')
                     err = recvmdm7 (junk);
                  if (err)
                     err = (receive_file (download_path, junk, prot) != NULL);
                  }
               XON_ENABLE ();
               gong ();
               break;

            case ALTF10:
               main_help ();
               break;

            case ALTF1:
            case ALTF2:
            case ALTF3:
            case ALTF4:
            case ALTF5:
            case ALTF6:
            case ALTF7:
            case ALTF8:
            case ALTF9:
               c = (k >> 8) - 0x68;
               if (keys[c] != NULL)
                  {
                  SENDCHARS (keys[c], strlen (keys[c]), 0);
                  }
               break;

            default:
               if (comm_bits == BITS_7)
                  c = k & 0x7f;
               else c = k & 0xff;

               if (c != 0)
                  while (Com_Tx_NW (c) == 0)
                    ;
               else ansi_map (k);
            }
         }
      if (c == -1)
         time_release ();
      }

   while (KEYPRESS ())
      {
      FOSSIL_CHAR ();
      }

   if (command_line_un)
      {
      mdm_init (modem_busy);
      DTR_OFF ();
      }

   gotoxy (0, 23);

   if (vfossil_installed)
      vfossil_close ();

   if (!share)
      MDM_DISABLE ();
   cprintf ("Thanks for using %s,\033[K\r\nAnother fine User-DEVELOPED software package!\033[K", ANNOUNCE);
   exit (1);
}

#ifdef OS_2 /*PLF Sun  05-07-1989  02:34:42 */
static int handler(void)     /* Function called at system interrupt */
{

    signal(SIGINT, SIG_IGN); /* Disallow CTRL + C during handler   */

    ctrlc_ctr++;

    signal(SIGINT,handler);       /* This is necessary so that the
                                ** next CTRL+C interrupt will call
                                ** "handler", since the DOS 3.x
                                ** operating system resets the
                                ** interrupt handler to the
                                ** system default after the
                                ** user-defined handler is called
                                */
    return(0);
}
#endif
