/* find.h : header file for code using the dir functions in find.c
**
**  Some of this file is a copy of MSC ver 5.00's <dos.h>.
**  It is included here because IBM C/2's <dos.h> is missing stuff.
**  No harm will come if you include either version of <dos.h>
**
**
** P. Fitzsimmons
*/



/*    FileFindBuf - structure of area where the filesystem driver
**      returns the results of the search (OS/2)
*/

struct FileFindBuf {
        unsigned create_date;           /* date of file creation */
        unsigned create_time;           /* time of file creation */
        unsigned access_date;           /* date of last access */
        unsigned access_time;           /* time of last access */
        unsigned wr_date;               /* date of last write */
        unsigned wr_time;               /* time of last write */
        unsigned long size;             /* file size (end of data) */
        unsigned long falloc_size;      /* file allocated size */
        unsigned attrib;                /* attributes of the file */
        unsigned char string_len;       /* returned length of ascii name str. */
                                        /* length does not include null byte */
        char name[13];                  /* name string */
        };

/* MSC 5.00 _dos_findfirst() structure, for MS-DOS mode */

#ifndef _FIND_T_DEFINED

struct find_t {
    char reserved[21];
    char attrib;
    unsigned wr_time;
    unsigned wr_date;
    long size;
    char name[13];
    };

#define _FIND_T_DEFINED

#endif

unsigned cdecl _dos_findfirst(char *, unsigned, struct find_t *);
unsigned cdecl _dos_findnext(struct find_t *);

/* File attribute constants */

#define _A_NORMAL       0x00    /* Normal file - No read/write restrictions */
#define _A_RDONLY       0x01    /* Read only file */
#define _A_HIDDEN       0x02    /* Hidden file */
#define _A_SYSTEM       0x04    /* System file */
#define _A_VOLID        0x08    /* Volume ID file */
#define _A_SUBDIR       0x10    /* Subdirectory */
#define _A_ARCH         0x20    /* Archive file */



/* type FSCAN has the common points of the above two structs.
**
*/

typedef struct filescanbuf{
        char name[13];      /* file name */
        char attrib;        /* file attributes */
        unsigned wr_time;   /* last time file was written to */
        unsigned wr_date;   /* last date file was written to */
        unsigned long size; /* size of file */
        void *findhandle;   /* under dos, this points to the DTA (a struct find_t) */
                            /* under os/2, it points to a (unsigned)FindHandle */
        char sig;           /* sentinal */
        }FSCAN;

#define FSCAN_SIG 0x44

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif


extern  FSCAN *opendir(void );
extern  void closedir(FSCAN *dh);
extern  int findfirst(char *mask,int attr,FSCAN *dh);
extern  int findnext(FSCAN *dh);
extern  long findtime(FSCAN *dh);

