/*--------------------------------------------------------------------------*/
/*																			*/
/*																			*/
/*		------------		 Bit-Bucket Software <no-Inc>					*/
/*		\ 10001101 /		 Writers and Distributors of					*/
/*		 \ 011110 / 		 No-Cost<no-tm> Software.						*/
/*		  \ 1011 /															*/
/*		   ------															*/
/*																			*/
/*	Copyright (C) 1987, 1988, 1989 by Robert Hartman and Vincent Perriello	*/
/*																			*/
/*																			*/
/*		   Definitions used in BinkleyTerm 2.10 File Transfer logic 		*/
/*																			*/
/*																			*/
/*	  For complete	details  of the licensing restrictions, please refer	*/
/*	  to the License  agreement,  which  is published in its entirety in	*/
/*	  the MAKEFILE and BT.C, and also contained in the file LICENSE.210.	*/
/*																			*/
/*	  USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE	*/
/*	  BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF	*/
/*	  THIS	AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,	OR IF YOU DO	*/
/*	  NOT HAVE THESE FILES,  YOU SHOULD  IMMEDIATELY CONTACT THE AUTHORS	*/
/*	  AT THE  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO	*/
/*	  USE	THIS  FILE	WITHOUT  HAVING   ACCEPTED	THE  TERMS	OF	 THE	*/
/*	  BINKLEYTERM  LICENSING AGREEMENT,  OR SUCH OTHER	AGREEMENT AS YOU	*/
/*	  ARE ABLE TO REACH WITH THE AUTHORS.									*/
/*																			*/
/*																			*/
/*	  The Authors can be reached at the following addresses:				*/
/*																			*/
/*	  Robert C. Hartman 					 Vincent E. Perriello			*/
/*	  Spark Software						 VEP Software					*/
/*	  427-3 Amherst Street					 111 Carroll Street 			*/
/*	  CS2032, Suite 232 					 Naugatuck, CT 06770			*/
/*	  Nashua, NH 03061														*/
/*																			*/
/*	  FidoNet 1:132/101 					 FidoNet 1:141/491				*/
/*	  Data	  (603) 888-8179				 Data	 (203) 729-7569 		*/
/*																			*/
/*	  Please feel free to contact us at any time to share your comments 	*/
/*	  about our software and/or licensing policies. 						*/
/*																			*/
/*																			*/
/*	This module is based largely on a similar module in OPUS-CBCS V1.03b.	*/
/*	The original work is (C) Copyright 1987, Wynn Wagner III. The original	*/
/*	author has graciously allowed us to use his code in this work.			*/
/*																			*/
/*--------------------------------------------------------------------------*/


#define  FILE_SECTION
#define  WAZOO_SECTION
#include "bink.h"

#define VERSION 2.20
#define BINK_MAJVERSION 2
#define BINK_MINVERSION 20
#define ANNOUNCE "BinkleyTerm Version 2.20.OS/2 (1:109/301)"
#define xfer_id "Binkley 2.20.OS/2"

#define read_binary "rb"
#define write_binary "wb"
#define read_ascii "rt"
#define write_ascii "wt"

#define stcgfn strcpy
#define wherex() fossil_wherex()
#define wherey() fossil_wherey()
#define gotoxy(x,y) fossil_gotoxy(x,y)
#define CLEAR_IOERR() errno = 0
#define wait_for_clear() while (!OUT_EMPTY())
#define TIMED_READ(a) com_getc(a)


/*--------------------------------------------------------------------------*/
/* Ascii character mnemonics												*/
/*--------------------------------------------------------------------------*/
#define NUL 0x00
#define SOH 0x01
#define STX 0x02
#define ETX 0x03
#define EOT 0x04
#define ENQ 0x05
#define ACK 0x06
#define BEL 0x07
#define BS	0x08
#define HT	0x09
#define LV	0x0a
#define VT	0x0b
#define FF	0x0c
#define CR	0x0d
#define SO	0x0e
#define SI	0x0f
#define DLE 0x10
#define DC1 0x11
#define DC2 0x12
#define DC3 0x13
#define DC4 0x14
#define NAK 0x15
#define SYN 0x16
#define ETB 0x17
#define CAN 0x18
#define EM	0x19
#define SUB 0x1a
#define ESC 0x1b
#define FS	0x1c
#define GS	0x1d
#define RS	0x1e
#define US	0x1f

/*--------------------------------------------------------------------------*/
/* Parameters for calling ZMODEM routines									*/
/*--------------------------------------------------------------------------*/
#define TRUE  1
#define FALSE 0
#define END_BATCH (-1)
#define DELETE_AFTER  '-'
#define SHOW_DELETE_AFTER '^'
#define TRUNC_AFTER   '#'
#define NOTHING_AFTER '@'
#define DO_WAZOO   TRUE

/* End of XFER.H */
